=== debian/changelog ===
calamares (3.2.41.1-0ubuntu4) jammy; urgency=medium

  * No-change rebuild against kpmcore 21.12.3

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Thu, 31 Mar 2022 12:55:23 -0700

calamares (3.2.41.1-0ubuntu3) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 14 Jan 2022 11:25:54 +0000

calamares (3.2.41.1-0ubuntu2) jammy; urgency=medium

  * Rebuild against new libyaml-cpp0.8.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 02 Dec 2021 09:46:17 +0100

calamares (3.2.41.1-0ubuntu1) impish; urgency=medium

  * New upstream release.
  * Refresh desktop patch to follow upstream changes.

 -- Dan Simmons <kc2bez@lubuntu.me>  Sat, 07 Aug 2021 15:08:35 -0400

calamares (3.2.37-0ubuntu3) impish; urgency=medium

  * For now build for arch any.

 -- Rik Mills <rikmills@kde.org>  Sat, 01 May 2021 20:25:52 +0100
