## calamares 3.2.55

=== debian/changelog ===
calamares (3.2.55-0xneon+20.04+focal+release+build52) focal; urgency=medium

  * Automatic CI Build

 -- Neon CI <neon@kde.org>  Mon, 18 Apr 2022 09:49:15 +0000

calamares (3.2.55-0neon) focal; urgency=medium

  * New release

 -- Harald Sitter <sitter@kde.org>  Tue, 07 Sep 2021 11:52:09 +0200

calamares (3.2.41.1-0neon) focal; urgency=medium

  * New release

 -- Harald Sitter <sitter@kde.org>  Wed, 04 Aug 2021 14:12:24 +0200

calamares (3.2.40-0neon) focal; urgency=medium

  * New release

 -- Harald Sitter <sitter@kde.org>  Thu, 15 Jul 2021 11:31:54 +0200

calamares (3.2.39.3-0neon) focal; urgency=medium

  * New release

 -- Harald Sitter <sitter@kde.org>  Fri, 16 Apr 2021 10:58:10 +0200

calamares (3.2.39.2-0neon) focal; urgency=medium

  * New release

 -- Harald Sitter <sitter@kde.org>  Tue, 06 Apr 2021 11:18:29 +0200

calamares (3.2.39.1-0neon) focal; urgency=medium

  * New release

 -- Harald Sitter <sitter@kde.org>  Wed, 31 Mar 2021 16:41:38 +0200

calamares (3.2.39-0neon) focal; urgency=medium

  * New release

 -- Harald Sitter <sitter@kde.org>  Mon, 22 Mar 2021 13:44:01 +0100

calamares (3.2.38.1-0neon) focal; urgency=medium

  * New release

 -- Harald Sitter <sitter@kde.org>  Mon, 15 Mar 2021 15:00:45 +0100

calamares (3.2.38-0neon) focal; urgency=medium

  * New release

 -- Harald Sitter <sitter@kde.org>  Mon, 15 Mar 2021 11:08:13 +0100

calamares (3.2.37-0neon) focal; urgency=medium

  * New release

 -- Harald Sitter <sitter@kde.org>  Wed, 24 Feb 2021 13:36:45 +0100

calamares (3.2.36-0neon) focal; urgency=medium

  * New release

 -- Harald Sitter <sitter@kde.org>  Fri, 12 Feb 2021 11:01:01 +0100
