=== debian/control ===
Source: calamares
Section: utils
Priority: optional
Build-Depends: cmake,
               cryptsetup,
               debhelper-compat (= 12),
               extra-cmake-modules,
               gettext,
               libappstreamqt-dev,
               libatasmart-dev,
               libboost-python-dev,
               libkf5config-dev,
               libkf5coreaddons-dev,
               libkf5crash-dev,
               libkf5i18n-dev,
               libkf5iconthemes-dev,
               libkf5kio-dev,
               libkf5package-dev,
               libkf5parts-dev,
               libkf5plasma-dev,
               libkf5service-dev,
               libkf5solid-dev,
               libkpmcore-dev,
               libparted-dev,
               libpolkit-qt5-1-dev,
               libpwquality-dev,
               libqt5svg5-dev,
               libyaml-cpp-dev,
               os-prober,
               pkg-config,
               pkg-kde-tools,
               policykit-1,
               python3-dev,
               qml-module-qtquick-layouts,
               qml-module-qtquick-privatewidgets,
               qml-module-qtquick-window2,
               qml-module-qtquick2,
               qtbase5-dev,
               qtdeclarative5-dev,
               qttools5-dev,
               qttools5-dev-tools,
               qtwebengine5-dev
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://github.com/calamares/calamares
Vcs-Git: https://invent.kde.org/neon/extras/calamares.git
Vcs-Browser: https://invent.kde.org/neon/extras/calamares
Maintainer: Neon CI <neon@kde.org>

Package: calamares
Architecture: linux-any
Depends: os-prober,
         qml-module-qtquick-window2,
         qml-module-qtquick2,
         rsync,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: btrfs-progs, grub-efi-amd64-bin, grub-pc, konsole, squashfs-tools
Description: distribution-independent installer framework
 Calamares is a distribution-independent installer framework.
 .
 It provides a graphical installer that can be used with nearly
 any distribution. This package is suitable for live media on
 Debian-based systems, and won't be of any particular use on
 an already installed system.
 .
 You will likely want to provide your own config files to match
 your distribution, reading the Calamares documentation will guide
 you through that process.
